/*
 * 2004  Abacus Research AG , St. Gallen , Switzerland . All rights reserved.
 * Terms of Use under The GNU GENERAL PUBLIC LICENSE Version 2
 *
 * THIS SOFTWARE IS PROVIDED BY ABACUS RESEARCH AG ``AS IS'' AND ANY EXPRESS 
 * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
 * WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, OR 
 * NON-INFRINGEMENT, ARE DISCLAIMED. IN NO EVENT SHALL ABACUS RESEARCH AG BE 
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 * POSSIBILITY OF SUCH DAMAGE.
 *
 */

/** Creator:
 * 03.05.2005 09:59:55 Misteli
 *
 * Maintainer:
 * 03.05.2005 09:59:55 Misteli
 *
 * Last Modification:
 * $Id: IconLabel.java,v 1.3 2005/09/20 07:44:25 misteli Exp $
 *
 * Copyright (c) 2003 ABACUS Research AG, All Rights Reserved
 */

package ch.abacus.lib.ui.propertyinspector.display;

import javax.swing.Icon;
import java.util.List;

public class IconLabel extends RenderLabel {

  private List<ch.abacus.lib.ui.propertyinspector.core.StringEntry> list;
  private List<Icon> icons;

  public IconLabel(List<ch.abacus.lib.ui.propertyinspector.core.StringEntry> list, List<Icon> icons) {
    this.list = list;
    this.icons = icons;
    setOpaque(true);
  }

  private int indexOf(Object value) {
    for (int i=0; i<list.size(); i++)
      if (list.get(i).equals(value))
        return i;
    return -1;
  }

  public void refreshLabel(Object value) {
    if (value == null)
      value = "";
    setText(value.toString());
    int index = indexOf(value);
    setIcon(null);
    if (index != -1 && icons != null)
      if (index < icons.size())
        setIcon(icons.get(index));
  }
}
