/*
 * 2004  Abacus Research AG , St. Gallen , Switzerland . All rights reserved.
 * Terms of Use under The GNU GENERAL PUBLIC LICENSE Version 2
 *
 * THIS SOFTWARE IS PROVIDED BY ABACUS RESEARCH AG ``AS IS'' AND ANY EXPRESS 
 * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
 * WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, OR 
 * NON-INFRINGEMENT, ARE DISCLAIMED. IN NO EVENT SHALL ABACUS RESEARCH AG BE 
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 * POSSIBILITY OF SUCH DAMAGE.
 *
 */

package ch.abacus.lib.ui.renderer.common;

import javax.swing.*;

/**
 * <p>Title: uifactory</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2001</p>
 * <p>Company: Abacus Research</p>
 * @author Michael Gouker (Cagey Logic)
 * @version 1.0
 */

public class HammerLNF {

    AbaMetaDataUser theUser;

    public HammerLNF(AbaMetaDataUser theUser, String sLNF) throws Exception {
        this.theUser = theUser;
        LookAndFeel theLNF = UIManager.getLookAndFeel();
        LookAndFeel theNewLNF = null;
        if ((sLNF != null) && (theLNF != null)) {
            theNewLNF = makeLookAndFeel(sLNF);
            if (theNewLNF.getClass().equals(theLNF.getClass()) == false)
                initLookAndFeel(theNewLNF);
        } else {
            if (sLNF != null) {
                theNewLNF = makeLookAndFeel(sLNF);
                initLookAndFeel(theNewLNF);
            }
        }
    }


    LookAndFeel makeLookAndFeel(String sLNFName) {
        try {
            Class cls = theUser.getClassLoader().getLoader().loadClass(sLNFName);
            if (cls != null) {
                try {
                    return (LookAndFeel) cls.newInstance();
                } catch (SecurityException e) {
                } catch (InstantiationException e) {
                } catch (IllegalAccessException e) {
                }
            }
        } catch (ClassNotFoundException e) {
        }
        return null;
    }

    private void initLookAndFeel(LookAndFeel theLNF) throws Exception {
        UIManager.setLookAndFeel(theLNF);
    }


}
