/*
 * 2004  Abacus Research AG , St. Gallen , Switzerland . All rights reserved.
 * Terms of Use under The GNU GENERAL PUBLIC LICENSE Version 2
 *
 * THIS SOFTWARE IS PROVIDED BY ABACUS RESEARCH AG ``AS IS'' AND ANY EXPRESS 
 * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
 * WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, OR 
 * NON-INFRINGEMENT, ARE DISCLAIMED. IN NO EVENT SHALL ABACUS RESEARCH AG BE 
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 * POSSIBILITY OF SUCH DAMAGE.
 *
 */

/*
 * Created by IntelliJ IDEA.
 * User: Administrator
 * Date: Aug 1, 2004
 * Time: 11:43:09 PM
 */
package ch.abacus.lib.ui.renderer.common.generator;

import ch.abacus.lib.ui.renderer.common.*;

public interface ProjectCodeGenerator {
    public ProjectDocument getProjectDocument();

    public void setProjectDocument(ProjectDocument theDocument);

    public void generateObjectCode(MetaObject theObject) throws HammerException;

    public String generatePropertyCode(MetaProperty theProperty) throws HammerException;

    public String generateParameterCode(MetaParameter theParameter, MetaPropertyDescriptor thePropDesc) throws HammerException;

    public void generateProjectCode(String sClassName, MetaProject theProject) throws HammerException;

    public String getDeclarationBuffer();

    public String getAssignmentBuffer();

    public BufferCollection getBufferCollection();

    public void setAssignmentBuffer(String sAssignmentBuffer);

    public void setDeclarationBuffer(String sDeclrationBuffer);

    public String getFormattedSource();

    void reset();
}