// copyright 2001-2002 by The Mind Electric

package electric.xml;

/**
 * <tt>Implementation</tt>.
 *
 * @author <a href="http://www.themindelectric.com">The Mind Electric</a>
 */

public class Implementation implements org.w3c.dom.DOMImplementation
  {
  /**
   * @param feature
   * @param version
   */
  public boolean hasFeature( String feature, String version )
    {
    if( feature.equalsIgnoreCase( "core" ) )
      return true;

    return false;
    }

  /**
   * @param qualifiedName
   * @param publicId
   * @param systemId
   */
  public org.w3c.dom.DocumentType createDocumentType( String qualifiedName, String publicId, String systemId )
    {
    return new DocType( "name" ); // HACK
    }

  /**
   * @param namespaceURI
   * @param qualifiedName
   * @param docType
   */
  public org.w3c.dom.Document createDocument( String namespaceURI, String qualifiedName, org.w3c.dom.DocumentType docType )
    {
    Document document = new Document();
    String[] parts = Element.getParts( qualifiedName );
    Element element = new Element( parts[ 1 ] );
    element.prefix = parts[ 0 ];
    element.namespace = namespaceURI;
    document.setRoot( element );

    if( docType != null )
      document.appendChild( (Node) docType );

    return document;
    }
  }